
#include "forms.h"
#include "mysqltutor.h"
#include "mysql.h"
#include "mdata.h"

#define BUFSIZE 100

#include "read_lesson.h"

/* MYSQL mysql;  */
/* MYSQL_RES *result;  */
MYSQL_ROW rows;

 int lessno = 1;  
char example[20];

/* callbacks for form main_form */
void
lesson (FL_OBJECT * ob, long data)
{
  /* fill-in code for callback */
}

void
out_put (FL_OBJECT * ob, long data)
{
  /* fill-in code for callback */
}

void
files (FL_OBJECT * ob, long data)
{

  int item = fl_get_menu (ob);
  char *tutordir;

  tutordir = (char *) malloc (512);
  if (!tutordir)
     return;


  switch (item)
    {
    case 1:
      {
	sprintf(tutordir, "%s/files/about.tut", LESSONDIR);
	fl_load_browser (about_browser, tutordir);
	fl_show_form (about_form, FL_PLACE_MOUSE, FL_TRANSIENT, "About MySQLTutor");
	free(tutordir);
	break;
      }
    case 2:
      {
	sprintf(tutordir, "%s/files/help.txt", LESSONDIR);
	fl_load_browser (help_browser, tutordir);
	fl_show_form (help_form, FL_PLACE_MOUSE, FL_TRANSIENT, "Help");
	free(tutordir);
	break;
      }
    case 3:
      {
	sprintf(tutordir, "%s/lessons/lessons", LESSONDIR);
	fl_load_browser (lesson_browser, tutordir);
	fl_show_form (lesson_form, FL_PLACE_MOUSE, FL_NOBORDER, "");
	free(tutordir);
	break;
      }
    case 4:
      {
	mysql_close (&mysql);
	free(tutordir);
	exit (1);
	break;
      }
    }

}

void
prev_lesson (FL_OBJECT * ob, long data)
{

  lessno = lessno--;

   if (lessno < 1 ) 
     { 
       fl_deactivate_object(prev_button);
       fl_activate_object(prev_button);
       lessno = 1;
       return; 
     } 

  read_lesson (lessno);

/*   lessno = 0; */


}

void
next_lesson (FL_OBJECT * ob, long data)
{
   int last_lesson = fl_get_browser_maxline(lesson_browser); 

  lessno++;

   if (lessno > last_lesson) 
       { 
 	fl_addto_browser(op_browser, "No more lessons installed."); 
	lessno = last_lesson;
	return; 
       } 


  read_lesson (lessno);

}

void
run_example (FL_OBJECT * ob, long data)
{

  char *query, *ins_id, *affected_rows;
  uint i = 0;
  int numFields = 0;

  fl_clear_browser (op_browser);


  query = (char *) malloc (2048);
  if (!query)
    return;

  ins_id = (char *) malloc (2048);
  if (!ins_id)
    return;

  affected_rows = (char *) malloc (2048);
  if (!affected_rows)
    return;

  sprintf (query, "%s", fl_get_input (ex_input));


  if (mysql_query (&mysql, query) == -1)
    {
      fl_addto_browser (op_browser, mysql_error (&mysql));
       return; 
    }

  if ((res = mysql_store_result (&mysql)) == NULL )
    {
      sprintf(ins_id, "Insert ID: %ld\n", mysql_insert_id(&mysql));
      sprintf(affected_rows, "Affected Rows: %ld\n", mysql_affected_rows(&mysql));

      fl_addto_browser(op_browser, ins_id);
      fl_addto_browser(op_browser, affected_rows);
    }
  else
    {
      numFields = mysql_num_fields(res);

      while ((row = mysql_fetch_row (res)) != NULL )
	{
	  for (i = 0; i < numFields ; i++)
	    fl_addto_browser (op_browser, row[i]);
	   /* fl_addto_browser (op_browser, "Query executed successfully."); */
	}
      fl_addto_browser (op_browser, "Query executed successfully.");
      mysql_free_result (res);
    }

   free (query); 
   free (ins_id);
   free (affected_rows);

}

void
ex_callback (FL_OBJECT * ob, long data)
{
  /* fill-in code for callback */
}



/* callbacks for form about_form */
void
about (FL_OBJECT * ob, long data)
{
  /* fill-in code for callback */
}

void
ok (FL_OBJECT * ob, long data)
{

  fl_hide_form (about_form);

}



/* callbacks for form help_form */
void
help (FL_OBJECT * ob, long data)
{
  /* fill-in code for callback */
}

void
help_ok (FL_OBJECT * ob, long data)
{

  fl_hide_form (help_form);

}



/* callbacks for form lesson_form */
void
lesson_cb (FL_OBJECT * ob, long data)
{

  if (data != 1)
    {
      lessno = fl_get_browser (lesson_browser);
    }
  else
    {
      lessno = 1;
    }

  read_lesson (lessno);

  fl_hide_form (lesson_form);

}
